=encoding utf8

=head1 NAME

Mail::Box::Locker::NFS - lock a folder with a separate file, NFS-safe

=head1 INHERITANCE

 Mail::Box::Locker::NFS
   is a Mail::Box::Locker
   is a Mail::Reporter

=head1 SYNOPSIS

  See Mail::Box::Locker

=head1 DESCRIPTION

Like the C<::DotLock> locker, but then in an NFS-safe fashion.  Over NFS,
the creation of a file is not atomic.  The C<::DotLock> locker depends
on an atomic C<open> system call, hence in not usable to lock a folder
which accessed over NFS.  The C<::NFS>
locker is therefore more complicated (so therefore slower), but will work
for NFS --and for local disks as well.

Extends L<"DESCRIPTION" in Mail::Box::Locker|Mail::Box::Locker/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Box::Locker|Mail::Box::Locker/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Box::Locker|Mail::Box::Locker/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Box::Locker/"METHODS">

 -Option --Defined in       --Default
  expires  Mail::Box::Locker  1 hour
  file     Mail::Box::Locker  undef
  folder   Mail::Box::Locker  <C<undef>>
  method   Mail::Box::Locker  'NFS'
  timeout  Mail::Box::Locker  10

=over 2

=item expires => $seconds

=item file => $file

=item folder => $folder

=item method => $name|CLASS|\@names

=item timeout => $seconds|'NOTIMEOUT'

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Box::Locker|Mail::Box::Locker/"Attributes">.

=over 4

=item $obj-E<gt>B<expires>( [SECONDS] )

Inherited, see L<Mail::Box::Locker/"Attributes">

=item $obj-E<gt>B<filename>( [$filename] )

Inherited, see L<Mail::Box::Locker/"Attributes">

=item $obj-E<gt>B<folder>( [$folder] )

Inherited, see L<Mail::Box::Locker/"Attributes">

=item $obj-E<gt>B<name>()

Inherited, see L<Mail::Box::Locker/"Attributes">

=item $obj-E<gt>B<timeout>( [SECONDS] )

Inherited, see L<Mail::Box::Locker/"Attributes">

=back

=head2 Locking

Extends L<"Locking" in Mail::Box::Locker|Mail::Box::Locker/"Locking">.

=over 4

=item $obj-E<gt>B<hasLock>()

Inherited, see L<Mail::Box::Locker/"Locking">

=item $obj-E<gt>B<isLocked>()

Inherited, see L<Mail::Box::Locker/"Locking">

=item $obj-E<gt>B<lock>()

Inherited, see L<Mail::Box::Locker/"Locking">

=item $obj-E<gt>B<unlock>()

Inherited, see L<Mail::Box::Locker/"Locking">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Box::Locker|Mail::Box::Locker/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Box::Locker|Mail::Box::Locker/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Box::Locker/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Fault: couldn't remove lockfile $file: $!

Cast by C<unlock()>

=item Warning: folder $name already locked over NFS.

Do not try to lock the folder when the application already has the
lock: it will give you dead-locks.
Cast by C<lock()>

=item Warning: removed expired lockfile $file.

A lock C<$file> was found which was older than the expiration period as
specified with L<new(timeout)|Mail::Box::Locker/"METHODS">.  The lock file was successfully
removed.
Cast by C<lock()>

=item Fault: unable to remove expired lockfile $file: $!

A lock file was found which was older than the expiration period as
specified with the L<new(timeout)|Mail::Box::Locker/"METHODS"> option.  It is impossible to remove that
lock file, so we need to wait until it vanishes by some external cause.
Cast by C<lock()>

=back

=head1 SEE ALSO

This module is part of Mail-Box version 4.02,
built on April 10, 2026. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

